package org.processmining.starstar.cep;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.Semaphore;

import org.processmining.starstar.elements.XOCEvent;
import org.processmining.starstar.elements.XOCObject;
import org.processmining.starstar.model.StarStarModel;

import com.espertech.esper.client.Configuration;
import com.espertech.esper.client.EPRuntime;
import com.espertech.esper.client.EPServiceProvider;
import com.espertech.esper.client.EPServiceProviderManager;

public class EsperChecker {
	// keep map of semaphores blocking the single events
	public Map<XOCEvent, Semaphore> blockSemaphores;
	// keep track of Esper conditions
	public EsperConditions esperConditions;
	// if provided, a list of events to check with Esper :)
	public List<XOCEvent> events;
	
	// configurations for Esper
	public Configuration cepConfig;
	public EPServiceProvider cep;
	public EPRuntime cepRT;
	
	// utility objects
	
	public void initializeBasicVariables() {
		// constructor
		this.blockSemaphores = new HashMap<XOCEvent, Semaphore>();
		this.esperConditions = new EsperConditions();
		this.events = new ArrayList<XOCEvent>();
		this.cepConfig = new Configuration();
	}
	
	public EsperChecker(StarStarModel model) {
		this.initializeBasicVariables();
		
		this.esperConditions = model.getEsperConditions().clone();
	}
	
	public void setConditions(EsperConditions conditions) {
		this.esperConditions = conditions;
	}
	
	public void addActivityAndClasses(List<XOCEvent> trainEvents) {
		for (XOCEvent event : trainEvents) {
			if (!esperConditions.activityCEPeventTypeCorrespondence.containsKey(event.getActivity().getActivityLabel())) {
				
			}
			for (XOCObject obj : event.getReferredObjects()) {

			}
		}
	}
	
	public void addActivityLabel(String activityLabel) {
		
	}
	
	public void addClassLabel(String classLabel) {
		
	}
	
	public void preRun() {
		this.cep = EPServiceProviderManager.getProvider("myCEPEngine", cepConfig);
		this.cepRT = cep.getEPRuntime();
	}
}
