package org.processmining.starstar.model;

import org.processmining.starstar.elements.XOCEvent;
import org.processmining.starstar.elements.XOCObject;

public class EventEdge {
	XOCEvent sourceEvent;
	XOCEvent targetEvent;
	XOCObject relationObject;
	Double weight;
	Double performance;

	public EventEdge(XOCEvent sourceEvent, XOCEvent targetEvent, XOCObject relationObject) {
		this.sourceEvent = sourceEvent;
		this.targetEvent = targetEvent;
		this.relationObject = relationObject;
		this.weight = 0.0;
		this.performance = 0.0;
		sourceEvent.addOutgoingEdge(this);
		targetEvent.addComingEdge(this);
	}
	
	public XOCEvent getSourceEvent() {
		return this.sourceEvent;
	}
	
	public XOCEvent getTargetEvent() {
		return this.targetEvent;
	}
	
	public XOCObject getRelationObject() {
		return this.relationObject;
	}
	
	public Double getWeight() {
		return this.weight;
	}
	
	public void setWeight(Double weight) {
		this.weight = weight;
	}
	
	public String getResume() {
		StringBuilder ret = new StringBuilder();
		ret.append("event edge from "+sourceEvent.getEventId()+" to "+targetEvent.getEventId()+" (weight: "+weight+"; performance: "+performance+")\n");
		return ret.toString();
	}
	
	public void printResume() {
		System.out.println(getResume());
	}
	
	public Double getPerformance() {
		return this.performance;
	}
	
	public void setPerformance(Double performance) {
		this.performance = performance;
	}
}
