package org.processmining.starstar.plugins;

import java.io.File;
import java.io.InputStream;

import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.starstar.model.StarStarModel;
import org.processmining.starstar.model.StarStarModelXOC;
import org.processmining.starstar.parser.ParsedXOC;

@Plugin(name = "Import Star Star Model from SLEX database", parameterLabels = { "Filename" }, returnLabels = {
"StarStarModel" }, returnTypes = { StarStarModel.class })
@UIImportPlugin(description = "Import Star Star Model from SLEX database", extensions = { "slexmm" })
public class StarStarModelSLEXImporter extends AbstractImportPlugin {
	private File file = null;

	protected StarStarModel importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		ParsedXOC parsedXOC = new ParsedXOC();
		parsedXOC.parseFromSqliteDatabase(filename);
		
		StarStarModel starStarModel = new StarStarModelXOC(parsedXOC);
		return starStarModel;
	}
	
	@Override
	@PluginVariant(requiredParameterLabels = { 0 })
	public Object importFile(PluginContext context, File f) throws Exception {
		file = f;
		InputStream stream = getInputStream(f);
		return importFromStream(context, stream, file.getAbsolutePath(), file.length());
	}
}
