package org.processmining.starstar.plugins;

import java.io.IOException;
import java.io.InputStream;
import java.io.StringWriter;

import org.apache.commons.io.IOUtils;
import org.processmining.contexts.uitopia.annotations.UIImportPlugin;
import org.processmining.framework.abstractplugins.AbstractImportPlugin;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.starstar.model.StarStarModel;
import org.processmining.starstar.model.StarStarModelXOC;
import org.processmining.starstar.parser.ParsedXOC;

@Plugin(name = "Import Star Star Model from XOC log file", parameterLabels = { "Filename" }, returnLabels = {
		"StarStarModel" }, returnTypes = { StarStarModel.class })
@UIImportPlugin(description = "Import Star Star Model from XOC log file", extensions = { "xoc" })
public class StarStarModelXOCImporter  extends AbstractImportPlugin {

	protected StarStarModel importFromStream(PluginContext context, InputStream input, String filename, long fileSizeInBytes)
			throws Exception {
		StringWriter writer = new StringWriter();
		try {
			IOUtils.copy(input, writer);
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		String text = writer.toString();

		// TODO Auto-generated method stub
		ParsedXOC parsedXOC = new ParsedXOC();
		parsedXOC.parseSimple(text, null);

		StarStarModel starStarModel = new StarStarModelXOC(parsedXOC);
		return starStarModel;
	}
}
