package org.processmining.starstar.visualizer;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;

import org.processmining.framework.plugin.PluginContext;
import org.processmining.starstar.elements.XOCActivity;
import org.processmining.starstar.model.ModelEdge;
import org.processmining.starstar.model.StarStarModel;
import org.processmining.starstar.model.Subgraph;

import com.mxgraph.layout.hierarchical.mxHierarchicalLayout;
import com.mxgraph.swing.mxGraphComponent;
import com.mxgraph.view.mxGraph;

public class SingleSubgraphElement extends JPanel {
	PluginContext context;
	StarStarModel model;
	LeftPanelStarStar leftPanel;
	ModelVisualizerStarStar visualizer;
	RightPanelStarStar rightPanel;
	XOCActivity selectedActivity;
	JPanel innerPanel;
	Subgraph subgraph;
	
	JPanel panel1;
	JPanel panel2;
	
	mxGraph graph;
	mxGraphComponent graphComponent;
	
	public SingleSubgraphElement(PluginContext context, StarStarModel model, LeftPanelStarStar leftPanel, ModelVisualizerStarStar visualizer, RightPanelStarStar rightPanel, XOCActivity selectedActivity, JPanel innerPanel, Subgraph subgraph) {
		this.context = context;
		this.model = model;
		this.leftPanel = leftPanel;
		this.visualizer = visualizer;
		this.rightPanel = rightPanel;
		this.selectedActivity = selectedActivity;
		this.innerPanel = innerPanel;
		this.subgraph = subgraph;
		
		
		//this.setPreferredSize(new Dimension(100, 520));
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		
		this.panel1 = new JPanel();
		this.panel1.setLayout(new BoxLayout(this.panel1, BoxLayout.X_AXIS));
		this.panel1.setPreferredSize(new Dimension(100, 30));
		this.panel2 = new JPanel();
		
		this.panel2.setPreferredSize(new Dimension(100, 380));
		
		JTextArea textArea = new JTextArea();
		textArea.setText(this.subgraph.getShortResume());
		//this.panel2.add(textArea);
		
		JLabel label = new JLabel();
		label.setText(this.subgraph.toString());
		this.panel1.add(label);
		
		JButton button = new JButton();
		button.setText("Filter on subgraph");
		SingleSubgraphElementActionListener sseal = new SingleSubgraphElementActionListener(context, model, leftPanel, visualizer, rightPanel, selectedActivity, innerPanel, subgraph);
		button.addActionListener(sseal);
		this.panel1.add(button);
		
		graph = new mxGraph();
		graph.getModel().beginUpdate();
		
		Object parent = graph.getDefaultParent();
		Map<XOCActivity, Object> mapOfVertex = new HashMap<XOCActivity, Object>();
		for (XOCActivity activity : subgraph.involvedActivitiesInEdges) {
			Object vertex = graph.insertVertex(parent, activity.getActivityLabel(), activity.getActivityLabel(), 150, 150, 150, 30);
			mapOfVertex.put(activity, vertex);
		}
		
		for (ModelEdge edge : subgraph.involvedEdges) {
			Object arc = graph.insertEdge(parent, null, edge.getRelationClass().getClassLabel(), mapOfVertex.get(edge.getSourceActivity()), mapOfVertex.get(edge.getTargetActivity()));
		}
		
		mxHierarchicalLayout layout = new mxHierarchicalLayout(graph);
		layout.execute(graph.getDefaultParent());
		graph.getModel().endUpdate();
		graphComponent = new mxGraphComponent(this.graph);
		
		this.panel2.add(graphComponent);
		
		this.add(this.panel1);
		this.add(this.panel2);
	}
}

class SingleSubgraphElementActionListener implements ActionListener {
	PluginContext context;
	StarStarModel model;
	LeftPanelStarStar leftPanel;
	ModelVisualizerStarStar visualizer;
	RightPanelStarStar rightPanel;
	XOCActivity selectedActivity;
	JPanel innerPanel;
	Subgraph subgraph;
	
	public SingleSubgraphElementActionListener(PluginContext context, StarStarModel model, LeftPanelStarStar leftPanel, ModelVisualizerStarStar visualizer, RightPanelStarStar rightPanel, XOCActivity selectedActivity, JPanel innerPanel, Subgraph subgraph) {
		this.context = context;
		this.model = model;
		this.leftPanel = leftPanel;
		this.visualizer = visualizer;
		this.rightPanel = rightPanel;
		this.selectedActivity = selectedActivity;
		this.innerPanel = innerPanel;
		this.subgraph = subgraph;
	}
	
	public void actionPerformed(ActionEvent e) {
		this.model.filterXocOnSubgraph(this.subgraph);
		this.rightPanel.destroyActivityFilterPanel();
		this.rightPanel.destroySubgraphVisualizer();
		this.visualizer.doRepresentationWork();
		this.visualizer.addGraphToView();
	}
}