package org.processmining.starstar.visualizer;

import java.awt.BorderLayout;
import java.util.List;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;

import org.processmining.framework.plugin.PluginContext;
import org.processmining.starstar.elements.XOCActivity;
import org.processmining.starstar.model.StarStarModel;
import org.processmining.starstar.model.Subgraph;

public class SubgraphVisualizer extends JPanel {
	public static int MAX_ADDED_SUBGRAPH_NUMBER = 7;
	
	PluginContext context;
	StarStarModel model;
	LeftPanelStarStar leftPanel;
	ModelVisualizerStarStar visualizer;
	RightPanelStarStar rightPanel;
	XOCActivity selectedActivity;
	List<Subgraph> subgraphs;
	
	JScrollPane scrollPane;
	JPanel innerPanel;
	
	JLabel subgraphVisualizerIntro;
	
	public SubgraphVisualizer(PluginContext context, StarStarModel model, LeftPanelStarStar leftPanel, ModelVisualizerStarStar visualizer, RightPanelStarStar rightPanel, XOCActivity selectedActivity) {
		this.context = context;
		this.model = model;
		this.leftPanel = leftPanel;
		this.visualizer = visualizer;
		this.rightPanel = rightPanel;
		this.selectedActivity = selectedActivity;
		
		this.subgraphs = this.model.discoverMostInterestingSubgraph(selectedActivity.getActivityLabel());
		this.setLayout(new BorderLayout());
		
		this.innerPanel = new JPanel();
		this.innerPanel.setLayout(new BoxLayout(this.innerPanel, BoxLayout.Y_AXIS));
		
		//this.innerPanel.setPreferredSize(new Dimension(500, 4000));
		
		this.subgraphVisualizerIntro = new JLabel("Most interesting subgraphs");
		this.innerPanel.add(this.subgraphVisualizerIntro);
		
		int i = 0;
		while (i < Math.min(this.subgraphs.size(), MAX_ADDED_SUBGRAPH_NUMBER)) {
			this.innerPanel.add(new SingleSubgraphElement(context, model, leftPanel, visualizer, rightPanel, selectedActivity, this.innerPanel, this.subgraphs.get(i)));
			i++;
		}
		
		this.scrollPane = new JScrollPane(innerPanel);
		this.scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		this.scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		
		this.add(this.scrollPane);
	}
}
